package fi.em.opplugin;

import com.alibaba.druid.util.StringUtils;
import fi.fa.opplugin.utils.ChangeDataUtils;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;

import kd.bos.entity.api.ApiResult;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.exception.KDBizException;
import kd.bos.metadata.botp.ConvertRuleReader;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

/**
 * @author cjz
 * @date 2024/8/30 10:37
 * @description:薪酬计提单手动下推代发处理
 */
public class AgentpayPushOpPlugin extends AbstractOperationServicePlugIn {

    private static String nckd_salarydistribute="nckd_salarydistribute";//薪酬计提发放单标识
    private static String cas_agentpaybill="cas_agentpaybill";//代发处理单标识



    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        super.beginOperationTransaction(e);
        if ("push".equals(e.getOperationKey())){
            DynamicObject[] dynamicObjects = e.getDataEntities();
            for (int i=0;i< dynamicObjects.length;i++)
            {
                //获取当前薪酬计提单
                DynamicObject info=BusinessDataServiceHelper
                        .loadSingle(dynamicObjects[i].getPkValue(),dynamicObjects[i].getDynamicObjectType().getName());
                //源单id
                Long pkid=info.getLong("id");
                // 下推参数，设置所选数据项
                List <ListSelectedRow> selectedRows=new ArrayList<>();
                ListSelectedRow selectedRow=new ListSelectedRow(pkid);
                //设置需要下推的单据名
//                selectedRow.setEntryEntityKey("nckd_salarydistribute");
                // 设置需要下推的单据体行内码：按分录下推时必须设置
                selectedRow.setEntryPrimaryKeyValue(pkid);
                selectedRows.add(selectedRow);
                // 创建下推参数
                PushArgs pushArgs = new PushArgs();
                // 源单标识
                pushArgs.setSourceEntityNumber(nckd_salarydistribute);
                // 目标单据标识
                pushArgs.setTargetEntityNumber(cas_agentpaybill);
                // 生成转换结果报告
                pushArgs.setBuildConvReport(true);
                //传入下推使用的转换规则id，不填则使用默认规则
//            pushArgs.setRuleId("");
                //下推默认保存
                pushArgs.setAutoSave(true);
                // 设置源单选中的数据包
                pushArgs.setSelectedRows(selectedRows);
                // 执行下推操作
                ConvertOperationResult result = ConvertServiceHelper.push(pushArgs);
                //获取下推目标单id
                Set<Object> targetBillIds = result.getTargetBillIds();
                if(!targetBillIds.isEmpty()) {
                    this.operationResult.setShowMessage(true);
                    this.operationResult.setSuccess(true);
                    this.operationResult.setMessage("下推代发处理单成功");
                }else {
                    this.operationResult.setShowMessage(true);
                    this.operationResult.setSuccess(false);
                    this.operationResult.setMessage("下推代发处理单失败");
                }
            }
        }
    }
}
